//
// Terrain - mixes 4 texture layers and a lightmap.
//
// ps2.0 - 1 pass
// ps1.1 - 2 passes, only 3 layers
// FFP - ??????????????????????????????????
// 

#include "_lib.fx"

float4x4	mWorld;
float4x4	mWorldView;
float4x4	mWVP;

texture tMix;
texture tBody;
texture tBase0, tBase1, tBase2;
texture tLightMap;

sampler2D smpMix = sampler_state {
	Texture = (tMix);
    MipFilter = Linear;	MinFilter = Linear; MagFilter = Linear;
    AddressU = Wrap; AddressV = Wrap;
};
sampler2D smpBody = sampler_state {
	Texture = (tBody);
    MipFilter = Linear;	MinFilter = Linear; MagFilter = Linear;
    AddressU = Wrap; AddressV = Wrap;
};
sampler2D smpBase0 = sampler_state {
	Texture = (tBase0);
    MipFilter = Linear;	MinFilter = Linear; MagFilter = Linear;
    AddressU = Wrap; AddressV = Wrap;
};
sampler2D smpBase1 = sampler_state {
	Texture = (tBase1);
    MipFilter = Linear;	MinFilter = Linear; MagFilter = Linear;
    AddressU = Wrap; AddressV = Wrap;
};
sampler2D smpBase2 = sampler_state {
	Texture = (tBase2);
    MipFilter = Linear;	MinFilter = Linear; MagFilter = Linear;
    AddressU = Wrap; AddressV = Wrap;
};
sampler2D smpLightMap = sampler_state {
	Texture = (tLightMap);
    MipFilter = Linear;	MinFilter = Linear; MagFilter = Linear;
    AddressU = Wrap; AddressV = Wrap;
};


#include "terrain_20path.fx"
#include "terrain_11path.fx"
#include "terrain_FFpath.fx"
